/*
 * This file is generated by jOOQ.
 */
package de.ship.clip.db.tables.records;


import de.ship.clip.db.enums.EnumLocale;
import de.ship.clip.db.tables.TTranslation;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TTranslationRecord extends UpdatableRecordImpl<TTranslationRecord> implements Record4<Integer, String, EnumLocale, String> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>config.t_translation.pk</code>.
     */
    public void setPk(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>config.t_translation.pk</code>.
     */
    public Integer getPk() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>config.t_translation.langkey</code>.
     */
    public void setLangkey(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>config.t_translation.langkey</code>.
     */
    public String getLangkey() {
        return (String) get(1);
    }

    /**
     * Setter for <code>config.t_translation.localecode</code>.
     */
    public void setLocalecode(EnumLocale value) {
        set(2, value);
    }

    /**
     * Getter for <code>config.t_translation.localecode</code>.
     */
    public EnumLocale getLocalecode() {
        return (EnumLocale) get(2);
    }

    /**
     * Setter for <code>config.t_translation.value</code>.
     */
    public void setValue(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>config.t_translation.value</code>.
     */
    public String getValue() {
        return (String) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row4<Integer, String, EnumLocale, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    @Override
    public Row4<Integer, String, EnumLocale, String> valuesRow() {
        return (Row4) super.valuesRow();
    }

    @Override
    public Field<Integer> field1() {
        return TTranslation.T_TRANSLATION.PK;
    }

    @Override
    public Field<String> field2() {
        return TTranslation.T_TRANSLATION.LANGKEY;
    }

    @Override
    public Field<EnumLocale> field3() {
        return TTranslation.T_TRANSLATION.LOCALECODE;
    }

    @Override
    public Field<String> field4() {
        return TTranslation.T_TRANSLATION.VALUE;
    }

    @Override
    public Integer component1() {
        return getPk();
    }

    @Override
    public String component2() {
        return getLangkey();
    }

    @Override
    public EnumLocale component3() {
        return getLocalecode();
    }

    @Override
    public String component4() {
        return getValue();
    }

    @Override
    public Integer value1() {
        return getPk();
    }

    @Override
    public String value2() {
        return getLangkey();
    }

    @Override
    public EnumLocale value3() {
        return getLocalecode();
    }

    @Override
    public String value4() {
        return getValue();
    }

    @Override
    public TTranslationRecord value1(Integer value) {
        setPk(value);
        return this;
    }

    @Override
    public TTranslationRecord value2(String value) {
        setLangkey(value);
        return this;
    }

    @Override
    public TTranslationRecord value3(EnumLocale value) {
        setLocalecode(value);
        return this;
    }

    @Override
    public TTranslationRecord value4(String value) {
        setValue(value);
        return this;
    }

    @Override
    public TTranslationRecord values(Integer value1, String value2, EnumLocale value3, String value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TTranslationRecord
     */
    public TTranslationRecord() {
        super(TTranslation.T_TRANSLATION);
    }

    /**
     * Create a detached, initialised TTranslationRecord
     */
    public TTranslationRecord(Integer pk, String langkey, EnumLocale localecode, String value) {
        super(TTranslation.T_TRANSLATION);

        setPk(pk);
        setLangkey(langkey);
        setLocalecode(localecode);
        setValue(value);
        resetChangedOnNotNull();
    }
}
